VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Sorting"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' ============================================================================
'        
'    QBasic    
'     VB      
' , , 08.05.2003
' ============================================================================

Private Sub Swap(a As Variant, b As Variant)
  '  QB,   VB
  Dim tmp As Variant
  tmp = a: a = b: b = tmp
End Sub

Private Function RandInt(Lower As Long, Upper As Long) As Long
  '      Lower  Upper .
  RandInt = Int(Rnd * (Upper - Lower + 1)) + Lower
End Function


' ================================  ===================================
'        SortArray,   
'        ,    .  
'    ,       .
' ============================================================================

Public Sub BubbleSort(SortArray())
  Dim i As Long, Switch As Long, Limit As Long
  
  Limit = UBound(SortArray)
  Do
    Switch = LBound(SortArray)
    For i = LBound(SortArray) To Limit - 1
      If SortArray(i) > SortArray(i + 1) Then Swap SortArray(i), SortArray(i + 1): Switch = i
    Next
    Limit = Switch
  Loop While Switch > LBound(SortArray)
End Sub

' =================================  ====================================
'         SortArray,  
'   ,    .     
'   ,    ,     
'   
' ============================================================================

Public Sub ExchangeSort(SortArray())
  Dim i As Long, SmallestRow As Long, j As Long
  
  For i = LBound(SortArray) To UBound(SortArray)
    SmallestRow = i
    For j = i + 1 To UBound(SortArray)
      If SortArray(j) < SortArray(SmallestRow) Then SmallestRow = j
    Next
    '    ,  
    If SmallestRow > i Then Swap SortArray(i), SortArray(SmallestRow)
  Next
End Sub

' =============================== HeapSort ===================================
'  HeapSort ,     - PercolateUp  PercolateDown.
'  PercolateUp  SortArray  "", (heap)   ,
'    :
'
'                               SortArray(1)
'                               /          \
'                    SortArray(2)           SortArray(3)
'                   /          \            /          \
'         SortArray(4)   SortArray(5)   SortArray(6)  SortArray(7)
'          /      \       /       \       /      \      /      \
'        ...      ...   ...       ...   ...      ...  ...      ...
'
'
'    " "    " ";
'  , SortArray(1)  SortArray(2)  SortArray(3),
'  SortArray(3)  SortArray(6)  SortArray(7),   .
'
'   ,    FOR...NEXT ,  
'    SortArray(1).
'
'    FOR...NEXT     SortArray(1)  
'  Ubound(),   (  PercolateDown)  
'  Ubound() - 1,      SortArray(1)   
'  Ubound() - 1,    Ubound() - 2,   
'  ,     .
' ============================================================================

Public Sub HeapSort(SortArray())
  Dim i As Long
  
  For i = LBound(SortArray) + 1 To UBound(SortArray)
    PercolateUp SortArray(), i
  Next
  
  For i = UBound(SortArray) To LBound(SortArray) + 1 Step -1
    Swap SortArray(LBound(SortArray)), SortArray(i)
    PercolateDown SortArray(), i - 1
  Next
End Sub

Private Sub PercolateDown(SortArr(), MaxLevel As Long)
  '     
  ' ,      ,   ,
  '   SortArray(-5 To 15),  .
  '          
  '    FakeIndex = RealIndex - LBound(SortArr) + 1
  '  ,  MaxLevel     
  Dim i As Long, Child As Long
  
  i = 1
  
  '   SortArray(1)   ,      
  ' ( ,         
  ' MaxLevel,   ):
  Do
    Child = 2 * i             '   .
    '   , :
    If Child > MaxLevel - LBound(SortArr) + 1 Then Exit Do
    '    ,  :
    If Child + 1 <= MaxLevel - LBound(SortArr) + 1 Then
      If SortArr(Child + 1 + LBound(SortArr) - 1) > SortArr(Child + LBound(SortArr) - 1) Then Child = Child + 1
    End If
    
    '   ,       
    If SortArr(i + LBound(SortArr) - 1) < SortArr(Child + LBound(SortArr) - 1) Then
      Swap SortArr(i + LBound(SortArr) - 1), SortArr(Child + LBound(SortArr) - 1)
      i = Child
    ' , SortArr      1  MaxLevel,   
    Else
      Exit Do
    End If
  Loop
End Sub

Private Sub PercolateUp(SortArr(), MaxLevel As Long)
  '      ,    PercolateDown
  Dim i As Long, Parent As Long
  i = MaxLevel - LBound(SortArr) + 1
  
  Do Until i = 1
    Parent = i \ 2            '  .
    If SortArr(i + LBound(SortArr) - 1) > SortArr(Parent + LBound(SortArr) - 1) Then
      Swap SortArr(Parent + LBound(SortArr) - 1), SortArr(i + LBound(SortArr) - 1)
      i = Parent
    Else
      Exit Do
    End If
  Loop
End Sub

' ================================  ===================================
'         
'    SortArray     .  
'        ,     
'   ,         .
' ============================================================================

Public Sub InsertionSort(SortArray())
  Dim TempVal As Variant, i As Long, j As Long
  
  For i = LBound(SortArray) + 1 To UBound(SortArray)
    TempVal = SortArray(i)
    
    For j = i To LBound(SortArray) + 1 Step -1
      
      '   ,   (j-1)-  ,  
      '    SortArray(i),  
      '   :
      If SortArray(j - 1) > TempVal Then
        SortArray(j) = SortArray(j - 1)
      '     FOR...NEXT:
      Else
        Exit For
      End If
    Next
    
    '    SortArray(i)  SortArray(j):
    SortArray(j) = TempVal
  Next
End Sub

' ==========================   ==============================
'         ""
'     SortArray,     ,  
'   "",     ,  ,   -  .
'            "", 
'    .       , 
'   ,    .
' ============================================================================

Public Sub QuickSort(SortArray(), Low As Long, High As Long)
  Dim RandIndex As Long, Partition As Variant
  Dim i As Long, j As Long
  
  If Low < High Then
    If Abs(High - Low) = 1 Then 'Abs  - -  . 
      '       ,    
      '   :
      If SortArray(Low) > SortArray(High) Then Swap SortArray(Low), SortArray(High)
    Else ',     !
      '   ,    :
      RandIndex = RandInt(Low, High)
      Swap SortArray(High), SortArray(RandIndex)
      Partition = SortArray(High)
      Do
        '        "":
        i = Low: j = High
        Do While (i < j) And (SortArray(i) <= Partition)
          i = i + 1
        Loop
        Do While (j > i) And (SortArray(j) >= Partition)
          j = j - 1
        Loop
        '     "",  ,  
        '      ,  :
        If i < j Then Swap SortArray(i), SortArray(j)
      Loop While i < j

      '        :
      Swap SortArray(i), SortArray(High)
      
      '   (   ,  
      '   ):
      If (i - Low) < (High - i) Then
        QuickSort SortArray(), Low, i - 1
        QuickSort SortArray(), i + 1, High
      Else
        QuickSort SortArray(), i + 1, High
        QuickSort SortArray(), Low, i - 1
      End If
    End If
  End If
End Sub


' =============================== ShellSort ==================================
'  ShellSort    .   
'   ,    (  
'  Offset  , Offset    
'  ),   ,   
'  ( Offset  1,      
'   ).
' ============================================================================

Public Sub ShellSort(SortArray())
  Dim Offset As Long, Limit As Long, Switch As Long, i As Long
  
  '  Offset    :
  Offset = (UBound(SortArray) - LBound(SortArray) + 1) \ 2
  
  Do While Offset > 0          ' ,  Offset    0.
    Limit = UBound(SortArray) - Offset
    Do
      Switch = LBound(SortArray) - 1 '  ,    .
      '      :
      For i = LBound(SortArray) To Limit
        If SortArray(i) > SortArray(i + Offset) Then
          Swap SortArray(i), SortArray(i + Offset)
          Switch = i
        End If
      Next
      
      '         :
      Limit = Switch - Offset
    Loop While Switch >= LBound(SortArray)

    '   ,  Offset :
    Offset = Offset \ 2
  Loop
End Sub
